Index: cpp/frams/model/similarity/simil_model.cpp
===================================================================
--- cpp/frams/model/similarity/simil_model.cpp	(revision 605)
+++ cpp/frams/model/similarity/simil_model.cpp	(revision 606)
@@ -1025,1020 +1025,1020 @@
 void ModelSimil::_PrintPartsMatching()
 {
-    // assure that matching exists
-    assert(m_pMatching != NULL);
-
-    printf("Parts matching:\n");
-    m_pMatching->PrintMatching();
+	// assure that matching exists
+	assert(m_pMatching != NULL);
+
+	printf("Parts matching:\n");
+	m_pMatching->PrintMatching();
 }
 
 void ModelSimil::ComputeMatching()
 {
-    // uniwersalne liczniki
-    int i, j;
-
-    assert(m_pMatching != NULL);
-    assert(m_pMatching->IsEmpty() == true);
-
-    // rozpoczynamy etap dopasowywania Parts w organizmach
-    // czy dopasowano już wszystkie Parts?
-    int iCzyDopasowane = 0;
-    // koniec grupy aktualnie dopasowywanej w każdym organizmie
-    int aiKoniecGrupyDopasowania[2] = {0, 0};
-    // koniec grupy już w całości dopasowanej
-    // (Pomiedzy tymi dwoma indeksami znajduja sie Parts w tablicy
-    // m_aDegrees, ktore moga byc dopasowywane (tam nadal moga
-    // byc tez dopasowane - ale nie musi to byc w sposob
-    // ciagly)
-    int aiKoniecPierwszejGrupy[2] = {0, 0};
-    // Tablica przechowująca odległości poszczególnych Parts z aktualnych
-    // grup dopasowania. Rozmiar - prostokąt o bokach równych liczbie elementów w 
-    // dopasowywanych aktualnie grupach. Pierwszy wymiar - pierwszy organizm.
-    // Drugi wymiar - drugi organizm (nie zależy to od tego, który jest mniejszy).
-    // Wliczane w rozmiar tablicy są nawet już dopasowane elementy - tablice
-    // paiCzyDopasowany pamiętają stan dopasowania tych elementów.
-    typedef double *TPDouble;
-    double **aadOdleglosciParts;
-    // dwie tablice okreslajace Parts, ktore moga byc do siebie dopasowywane
-    // rozmiary: [0] - aiRozmiarCalychGrup[1]
-    //			 [1] - aiRozmiarCalychGrup[0]
-    std::vector<bool> *apvbCzyMinimalnaOdleglosc[2];
-    // rozmiar aktualnie dopasowywanej grupy w odpowiednim organizmie (tylko elementy
-    // jeszcze niedopasowane).
-    int aiRozmiarGrupy[2];
-    // rozmiar aktualnie dopasowywanych grup w odpowiednim organizmie (włączone są
-    // w to również elementy już dopasowane).
-    int aiRozmiarCalychGrup[2] = {0, 0};
-
-    // utworzenie tablicy rozmiarow
-    for (i = 0; i < 2; i++)
-    {
-        m_aiPartCount[i] = m_Mod[i]->getPartCount();
-    }
-
-    // DOPASOWYWANIE PARTS
-    while (!iCzyDopasowane)
-    {
-        // znajdz konce obu grup aktualnie dopasowywanych w obu organizmach
-        for (i = 0; i < 2; i++)
-        {
-            // czyli poszukaj miejsca zmiany stopnia lub konca tablicy
-            for (j = aiKoniecPierwszejGrupy[i] + 1; j < m_aiPartCount[i]; j++)
-            {
-                if (m_aDegrees[i][j][DEGREE] < m_aDegrees[i][j - 1][DEGREE])
-                {
-                    break;
-                }
-            }
-            aiKoniecGrupyDopasowania[i] = j;
-
-            // sprawdz poprawnosc tego indeksu
-            assert((aiKoniecGrupyDopasowania[i] > 0) &&
-                   (aiKoniecGrupyDopasowania[i] <= m_aiPartCount[i]));
-
-            // oblicz rozmiary całych grup - łącznie z dopasowanymi już elementami
-            aiRozmiarCalychGrup[i] = aiKoniecGrupyDopasowania[i] -
-                    aiKoniecPierwszejGrupy[i];
-
-            // sprawdz teraz rozmiar tej grupy w sensie liczby niedopasowanzch
-            // nie moze to byc puste!
-            aiRozmiarGrupy[i] = 0;
-            for (j = aiKoniecPierwszejGrupy[i]; j < aiKoniecGrupyDopasowania[i]; j++)
-            {
-                // od poczatku do konca grupy
-                if (!m_pMatching->IsMatched(i, j))
-                {
-                    // jesli niedopasowany, to zwieksz licznik
-                    aiRozmiarGrupy[i]++;
-                }
-            }
-            // grupa nie moze byc pusta!
-            assert(aiRozmiarGrupy[i] > 0);
-        }
-
-        // DOPASOWYWANIE PARTS Z GRUP
-
-        // stworzenie tablicy odległości lokalnych
-        // stwórz pierwszy wymiar - wg rozmiaru zerowego organizmu
-        aadOdleglosciParts = new TPDouble[ aiRozmiarCalychGrup[0] ];
-        assert(aadOdleglosciParts != NULL);
-        // stwórz drugi wymiar - wg rozmiaru drugiego organizmu
-        for (i = 0; i < aiRozmiarCalychGrup[0]; i++)
-        {
-            aadOdleglosciParts[i] = new double [ aiRozmiarCalychGrup[1] ];
-            assert(aadOdleglosciParts[i] != NULL);
-        }
-
-        // stworzenie tablic mozliwosci dopasowania (indykatorow minimalnej odleglosci)
-        apvbCzyMinimalnaOdleglosc[0] = new std::vector<bool>(aiRozmiarCalychGrup[1], false);
-        apvbCzyMinimalnaOdleglosc[1] = new std::vector<bool>(aiRozmiarCalychGrup[0], false);
-        // sprawdz stworzenie tablic
-        assert(apvbCzyMinimalnaOdleglosc[0] != NULL);
-        assert(apvbCzyMinimalnaOdleglosc[1] != NULL);
-
-        // wypełnienie elementów macierzy (i,j) odległościami pomiędzy
-        // odpowiednimi Parts: (i) w organizmie 0 i (j) w organizmie 1.
-        // UWAGA! Uwzględniamy tylko te Parts, które nie są jeszcze dopasowane
-        // (reszta to byłaby po prostu strata czasu).
-        int iDeg, iNeu; // ilościowe określenie różnic stopnia, liczby neuronów i połączeń Parts
-        //int iNIt;
-        double dGeo; // ilościowe określenie różnic geometrycznych pomiędzy Parts
-        // indeksy konkretnych Parts - indeksy sa ZERO-BASED, choć właściwy dostep
-        // do informacji o Part wymaga dodania aiKoniecPierwszejGrupy[]
-        // tylko aadOdleglosciParts[][] indeksuje sie bezposrednio zawartoscia iIndex[]
-        int iIndex[2];
-        int iPartIndex[ 2 ] = {-1, -1}; // at [iModel]: original index of a Part for the specified model (iModel)
-
-        // debug - wypisz zakres dopasowywanych indeksow
-        DB(printf("Organizm 0: grupa: (%2i, %2i)\n", aiKoniecPierwszejGrupy[0],
-                  aiKoniecGrupyDopasowania[0]);)
-                DB(printf("Organizm 1: grupa: (%2i, %2i)\n", aiKoniecPierwszejGrupy[1],
-                          aiKoniecGrupyDopasowania[1]);)
-
-        for (i = 0; i < aiRozmiarCalychGrup[0]; i++)
-        {
-
-            // iterujemy i - Parts organizmu 0
-            // (indeks podstawowy - aiKoniecPierwszejGrupy[0])
-
-            if (!(m_pMatching->IsMatched(0, aiKoniecPierwszejGrupy[0] + i)))
-            {
-                // interesuja nas tylko te niedopasowane jeszcze (i)
-                for (j = 0; j < aiRozmiarCalychGrup[1]; j++)
-                {
-
-                    // iterujemy j - Parts organizmu 1
-                    // (indeks podstawowy - aiKoniecPierwszejGrupy[1])
-
-                    if (!(m_pMatching->IsMatched(1, aiKoniecPierwszejGrupy[1] + j)))
-                    {
-                        // interesuja nas tylko te niedopasowane jeszcze (j)
-                        // teraz obliczymy lokalne różnice pomiędzy Parts
-                        iDeg = abs(m_aDegrees[0][ aiKoniecPierwszejGrupy[0] + i ][1]
-                                   - m_aDegrees[1][ aiKoniecPierwszejGrupy[1] + j ][1]);
-
-                        //iNit currently is not a component of distance measure            
-                        //iNIt = abs(m_aDegrees[0][ aiKoniecPierwszejGrupy[0] + i ][2]
-                        //           - m_aDegrees[1][ aiKoniecPierwszejGrupy[1] + j ][2]);
-
-                        iNeu = abs(m_aDegrees[0][ aiKoniecPierwszejGrupy[0] + i ][3]
-                                   - m_aDegrees[1][ aiKoniecPierwszejGrupy[1] + j ][3]);
-
-                        // obliczenie także lokalnych różnic geometrycznych pomiędzy Parts
-                        // find original indices of Parts for both of the models
-                        iPartIndex[ 0 ] = m_aDegrees[0][ aiKoniecPierwszejGrupy[0] + i ][ 0 ];
-                        iPartIndex[ 1 ] = m_aDegrees[1][ aiKoniecPierwszejGrupy[1] + j ][ 0 ];
-                        // now compute the geometrical distance of these Parts (use m_aPositions
-                        // which should be computed by SVD)
-                        Pt3D Part0Pos(m_aPositions[ 0 ][ iPartIndex[ 0 ] ]);
-                        Pt3D Part1Pos(m_aPositions[ 1 ][ iPartIndex[ 1 ] ]);
-                        dGeo = m_adFactors[3] == 0 ? 0 : Part0Pos.distanceTo(Part1Pos); //no need to compute distane when m_dDG weight is 0
-
-                        // tutaj prawdopodobnie należy jeszcze dodać sprawdzanie
-                        // identyczności pozostałych własności (oprócz geometrii)
-                        // - żeby móc stwierdzić w ogóle identyczność Parts
-
-                        // i ostateczna odleglosc indukowana przez te roznice
-                        // (tutaj nie ma różnicy w liczbie wszystkich wierzchołków)
-                        aadOdleglosciParts[i][j] = m_adFactors[1] * double(iDeg) +
-                                m_adFactors[2] * double(iNeu) +
-                                m_adFactors[3] * dGeo;
-                        DB(printf("Parts Distance (%2i,%2i) = %.3lf\n", aiKoniecPierwszejGrupy[0] + i,
-                                  aiKoniecPierwszejGrupy[1] + j, aadOdleglosciParts[i][j]);)
-                                DB(printf("Parts geometrical distance = %.20lf\n", dGeo);)
-                                DB(printf("Pos0: (%.3lf %.3lf %.3lf)\n", Part0Pos.x, Part0Pos.y, Part0Pos.z);)
-                                DB(printf("Pos1: (%.3lf %.3lf %.3lf)\n", Part1Pos.x, Part1Pos.y, Part1Pos.z);)
-                    }
-                }
-            }
-        }
-
-        // tutaj - sprawdzic tylko, czy tablica odleglosci lokalnych jest poprawnie obliczona
-
-        // WYKORZYSTANIE TABLICY ODLEGLOSCI DO BUDOWY DOPASOWANIA
-
-        // trzeba raczej iterować aż do zebrania wszystkich możliwych dopasowań w grupie
-        // dlatego wprowadzamy dodatkowa zmienna - czy skonczyla sie juz grupa
-        bool bCzyKoniecGrupy = false;
-        while (!bCzyKoniecGrupy)
-        {
-            for (i = 0; i < 2; i++)
-            {
-                // iterujemy (i) po organizmach
-                // szukamy najpierw jakiegoś niedopasowanego jeszcze Part w organizmach
-
-                // zakładamy, że nie ma takiego Part
-                iIndex[i] = -1;
-
-                for (j = 0; j < aiRozmiarCalychGrup[ i ]; j++)
-                {
-                    // iterujemy (j) - Parts organizmu (i)
-                    // (indeks podstawowy - aiKoniecPierwszejGrupy[0])
-                    if (!(m_pMatching->IsMatched(i, aiKoniecPierwszejGrupy[i] + j)))
-                    {
-                        // gdy mamy w tej grupie jakis niedopasowany element, to ustawiamy
-                        // iIndex[i] (chcemy w zasadzie pierwszy taki)
-                        iIndex[i] = j;
-                        break;
-                    }
-                }
-
-                // sprawdzamy, czy w ogole znaleziono taki Part
-                if (iIndex[i] < 0)
-                {
-                    // gdy nie znaleziono takiego Part - mamy koniec dopasowywania w
-                    // tych grupach
-                    bCzyKoniecGrupy = true;
-                }
-                // sprawdz poprawnosc indeksu niedopasowanego Part - musi byc w aktualnej grupie
-                assert((iIndex[i] >= -1) && (iIndex[i] < aiRozmiarCalychGrup[i]));
-            }
-
-
-            // teraz mamy sytuacje:
-            // - mamy w iIndex[0] i iIndex[1] indeksy pierwszych niedopasowanych Part
-            //		w organizmach, albo
-            // - nie ma w ogóle już czego dopasowywać (należy przejść do innej grupy)
-            if (!bCzyKoniecGrupy)
-            {
-                // gdy nie ma jeszcze końca żadnej z grup - możemy dopasowywać
-                // najpierw wyszukujemy w tablicy minimum odległości od tych
-                // wyznaczonych Parts
-
-                // najpierw wyczyscimy wektory potencjalnych dopasowan
-                // dla organizmu 1 (o rozmiarze grupy z 0)
-                for (i = 0; i < aiRozmiarCalychGrup[0]; i++)
-                {
-                    apvbCzyMinimalnaOdleglosc[1]->operator[](i) = false;
-                }
-                // dla organizmu 0 (o rozmiarze grup z 1)
-                for (i = 0; i < aiRozmiarCalychGrup[1]; i++)
-                {
-                    apvbCzyMinimalnaOdleglosc[0]->operator[](i) = false;
-                }
-
-                // szukanie minimum dla Part o indeksie iIndex[0] w organizmie 0
-                // wsrod niedopasowanych Parts z organizmu 1
-                // zakładamy, że nie znaleliśmy jeszcze minimum
-                double dMinimum = HUGE_VAL;
-                for (i = 0; i < aiRozmiarCalychGrup[1]; i++)
-                {
-                    if (!(m_pMatching->IsMatched(1, aiKoniecPierwszejGrupy[1] + i)))
-                    {
-
-                        // szukamy minimum obliczonej lokalnej odleglosci tylko wsrod
-                        // niedopasowanych jeszcze Parts
-                        if (aadOdleglosciParts[ iIndex[0] ][ i ] < dMinimum)
-                        {
-                            dMinimum = aadOdleglosciParts[ iIndex[0] ][ i ];
-                        }
-
-                        // przy okazji - sprawdz, czy HUGE_VAL jest rzeczywiscie max dla double
-                        assert(aadOdleglosciParts[ iIndex[0] ][ i ] < HUGE_VAL);
-                    }
-                }
-                // sprawdz, czy minimum znaleziono - musi takie byc, bo jest cos niedopasowanego
-                assert((dMinimum >= 0.0) && (dMinimum < HUGE_VAL));
-
-                // teraz zaznaczamy w tablicy te wszystkie Parts, ktore maja
-                // rzeczywiscie te minimalna odleglosc do Part iIndex[0] w organizmie 0
-                for (i = 0; i < aiRozmiarCalychGrup[1]; i++)
-                {
-                    if (!(m_pMatching->IsMatched(1, aiKoniecPierwszejGrupy[1] + i)))
-                    {
-                        if (aadOdleglosciParts[ iIndex[0] ][ i ] == dMinimum)
-                        {
-                            // jesli w danym miejscu tablicy odleglosci jest faktyczne
-                            // minimum odleglosci, to mamy potencjalna pare dla iIndex[0]
-                            apvbCzyMinimalnaOdleglosc[0]->operator[](i) = true;
-                        }
-
-                        // sprawdz poprawnosc znalezionego wczesniej minimum
-                        assert(aadOdleglosciParts[ iIndex[0] ][ i ] >= dMinimum);
-                    }
-                }
-
-                // podobnie szukamy minimum dla Part o indeksie iIndex[1] w organizmie 1
-                // wsrod niedopasowanych Parts z organizmu 0
-                dMinimum = HUGE_VAL;
-                for (i = 0; i < aiRozmiarCalychGrup[0]; i++)
-                {
-                    if (!(m_pMatching->IsMatched(0, aiKoniecPierwszejGrupy[0] + i)))
-                    {
-                        // szukamy minimum obliczonej lokalnej odleglosci tylko wsrod
-                        // niedopasowanych jeszcze Parts
-                        if (aadOdleglosciParts[ i ][ iIndex[1] ] < dMinimum)
-                        {
-                            dMinimum = aadOdleglosciParts[ i ][ iIndex[1] ];
-                        }
-                        // przy okazji - sprawdz, czy HUGE_VAL jest rzeczywiscie max dla double
-                        assert(aadOdleglosciParts[ i ][ iIndex[1] ] < HUGE_VAL);
-                    }
-                }
-                // sprawdz, czy minimum znaleziono - musi takie byc, bo jest cos niedopasowanego
-                assert((dMinimum >= 0.0) && (dMinimum < HUGE_VAL));
-
-                // teraz zaznaczamy w tablicy te wszystkie Parts, ktore maja
-                // rzeczywiscie te minimalne odleglosci do Part iIndex[1] w organizmie 1
-                for (i = 0; i < aiRozmiarCalychGrup[0]; i++)
-                {
-                    if (!(m_pMatching->IsMatched(0, aiKoniecPierwszejGrupy[0] + i)))
-                    {
-                        if (aadOdleglosciParts[ i ][ iIndex[1] ] == dMinimum)
-                        {
-                            // jesli w danym miejscu tablicy odleglosci jest faktyczne
-                            // minimum odleglosci, to mamy potencjalna pare dla iIndex[1]
-                            apvbCzyMinimalnaOdleglosc[1]->operator[](i) = true;
-                        }
-
-                        // sprawdz poprawnosc znalezionego wczesniej minimum
-                        assert(aadOdleglosciParts[ i ][ iIndex[1] ] >= dMinimum);
-                    }
-                }
-
-                // teraz mamy juz poszukane potencjalne grupy dopasowania - musimy
-                // zdecydowac, co do czego dopasujemy!
-                // szukamy Part iIndex[0] posrod mozliwych do dopasowania dla Part iIndex[1]
-                // szukamy takze Part iIndex[1] posrod mozliwych do dopasowania dla Part iIndex[0]
-                bool PartZ1NaLiscie0 = apvbCzyMinimalnaOdleglosc[0]->operator[](iIndex[1]);
-                bool PartZ0NaLiscie1 = apvbCzyMinimalnaOdleglosc[1]->operator[](iIndex[0]);
-
-                if (PartZ1NaLiscie0 && PartZ0NaLiscie1)
-                {
-                    // PRZYPADEK 1. Oba Parts maja sie wzajemnie na listach mozliwych
-                    // dopasowan.
-                    // AKCJA. Dopasowanie wzajemne do siebie.
-
-                    m_pMatching->Match(0, aiKoniecPierwszejGrupy[0] + iIndex[0],
-                                       1, aiKoniecPierwszejGrupy[1] + iIndex[1]);
-
-                    // zmniejsz liczby niedopasowanych elementow w grupach
-                    aiRozmiarGrupy[0]--;
-                    aiRozmiarGrupy[1]--;
-                    // debug - co zostalo dopasowane
-                    DB(printf("Przypadek 1.: dopasowane Parts: (%2i, %2i)\n", aiKoniecPierwszejGrupy[0]
-                              + iIndex[0], aiKoniecPierwszejGrupy[1] + iIndex[1]);)
-
-                }// PRZYPADEK 1.
-                else
-                    if (PartZ1NaLiscie0 || PartZ0NaLiscie1)
-                {
-                    // PRZYPADEK 2. Tylko jeden z Parts ma drugiego na swojej liscie
-                    // mozliwych dopasowan
-                    // AKCJA. Dopasowanie jednego jest proste (tego, ktory nie ma 
-                    // na swojej liscie drugiego). Dla tego drugiego nalezy powtorzyc
-                    // duza czesc obliczen (znalezc mu nowa mozliwa pare)
-
-                    // indeks organizmu, ktorego Part nie ma dopasowywanego Part
-                    // z drugiego organizmu na swojej liscie
-                    int iBezDrugiego;
-
-                    // okreslenie indeksu organizmu z dopasowywanym Part
-                    if (!PartZ1NaLiscie0)
-                    {
-                        iBezDrugiego = 0;
-                    }
-                    else
-                    {
-                        iBezDrugiego = 1;
-                    }
-                    // sprawdz indeks organizmu
-                    assert((iBezDrugiego == 0) || (iBezDrugiego == 1));
-
-                    int iDopasowywany = -1;
-                    // poszukujemy pierwszego z listy dopasowania
-                    for (i = 0; i < aiRozmiarCalychGrup[ 1 - iBezDrugiego ]; i++)
-                    {
-                        if (apvbCzyMinimalnaOdleglosc[iBezDrugiego]->operator[](i))
-                        {
-                            iDopasowywany = i;
-                            break;
-                        }
-                    }
-                    // sprawdz poprawnosc indeksu dopasowywanego (musimy cos znalezc!)
-                    // nieujemny i w odpowiedniej grupie!
-                    assert((iDopasowywany >= 0) &&
-                           (iDopasowywany < aiRozmiarCalychGrup[ 1 - iBezDrugiego ]));
-
-                    // znalezlismy 1. Part z listy dopasowania - dopasowujemy!
-                    m_pMatching->Match(
-                                       iBezDrugiego,
-                                       aiKoniecPierwszejGrupy[ iBezDrugiego ] + iIndex[ iBezDrugiego ],
-                                       1 - iBezDrugiego,
-                                       aiKoniecPierwszejGrupy[ 1 - iBezDrugiego ] + iDopasowywany);
-                    DB(printf("Przypadek 2.1.: dopasowane Parts dopasowanie bez drugiego: (%2i, %2i)\n", aiKoniecPierwszejGrupy[ iBezDrugiego ] + iIndex[ iBezDrugiego ],
-                              aiKoniecPierwszejGrupy[ 1 - iBezDrugiego ] + iDopasowywany);)
-
-                            // zmniejsz liczby niedopasowanych elementow w grupach
-                            aiRozmiarGrupy[0]--;
-                    aiRozmiarGrupy[1]--;
-
-                    // sprawdz, czy jest szansa dopasowania tego Part z drugiej strony
-                    // (ktora miala mozliwosc dopasowania tego Part z poprzedniego organizmu)
-                    if ((aiRozmiarGrupy[0] > 0) && (aiRozmiarGrupy[1] > 0))
-                    {
-                        // jesli grupy sie jeszcze nie wyczrpaly
-                        // to jest mozliwosc dopasowania w organizmie
-
-                        int iZDrugim = 1 - iBezDrugiego;
-                        // sprawdz indeks organizmu
-                        assert((iZDrugim == 0) || (iZDrugim == 1));
-
-                        // bedziemy szukac minimum wsrod niedopasowanych - musimy wykasowac
-                        // poprzednie obliczenia minimum
-                        // dla organizmu 1 (o rozmiarze grupy z 0)
-                        for (i = 0; i < aiRozmiarCalychGrup[0]; i++)
-                        {
-                            apvbCzyMinimalnaOdleglosc[1]->operator[](i) = false;
-                        }
-                        // dla organizmu 0 (o rozmiarze grup z 1)
-                        for (i = 0; i < aiRozmiarCalychGrup[1]; i++)
-                        {
-                            apvbCzyMinimalnaOdleglosc[0]->operator[](i) = false;
-                        }
-
-                        // szukamy na nowo minimum dla Part o indeksie iIndex[ iZDrugim ] w organizmie iZDrugim
-                        // wsrod niedopasowanych Parts z organizmu 1 - iZDrugim
-                        dMinimum = HUGE_VAL;
-                        for (i = 0; i < aiRozmiarCalychGrup[ 1 - iZDrugim ]; i++)
-                        {
-                            if (!(m_pMatching->IsMatched(
-                                                         1 - iZDrugim,
-                                                         aiKoniecPierwszejGrupy[ 1 - iZDrugim ] + i)))
-                            {
-                                // szukamy minimum obliczonej lokalnej odleglosci tylko wsrod
-                                // niedopasowanych jeszcze Parts
-                                if (iZDrugim == 0)
-                                {
-                                    // teraz niestety musimy rozpoznac odpowiedni organizm
-                                    // zeby moc indeksowac niesymetryczna tablice
-                                    if (aadOdleglosciParts[ iIndex[0] ][ i ] < dMinimum)
-                                    {
-                                        dMinimum = aadOdleglosciParts[ iIndex[0] ][ i ];
-                                    }
-                                    // przy okazji - sprawdz, czy HUGE_VAL jest rzeczywiscie max dla double
-                                    assert(aadOdleglosciParts[ iIndex[0] ][ i ] < HUGE_VAL);
-
-                                }
-                                else
-                                {
-                                    if (aadOdleglosciParts[ i ][ iIndex[1] ] < dMinimum)
-                                    {
-                                        dMinimum = aadOdleglosciParts[ i ][ iIndex[1] ];
-                                    }
-                                    // przy okazji - sprawdz, czy HUGE_VAL jest rzeczywiscie max dla double
-                                    assert(aadOdleglosciParts[ i ][ iIndex[1] ] < HUGE_VAL);
-                                }
-                            }
-                        }
-                        // sprawdz, czy minimum znaleziono - musi takie byc, bo jest cos niedopasowanego
-                        assert((dMinimum >= 0.0) && (dMinimum < HUGE_VAL));
-
-                        // teraz zaznaczamy w tablicy te wszystkie Parts, ktore maja
-                        // rzeczywiscie te minimalne odleglosci do Part w organizmie iZDrugim
-                        for (i = 0; i < aiRozmiarCalychGrup[ 1 - iZDrugim ]; i++)
-                        {
-                            if (!(m_pMatching->IsMatched(
-                                                         1 - iZDrugim,
-                                                         aiKoniecPierwszejGrupy[ 1 - iZDrugim ] + i)))
-                            {
-                                if (iZDrugim == 0)
-                                {
-                                    // teraz niestety musimy rozpoznac odpowiedni organizm
-                                    // zeby moc indeksowac niesymetryczna tablice
-                                    if (aadOdleglosciParts[ iIndex[0] ][ i ] == dMinimum)
-                                    {
-                                        // jesli w danym miejscu tablicy odleglosci jest faktyczne 
-                                        // minimum odleglosci, to mamy potencjalna pare dla iIndex[1]
-                                        apvbCzyMinimalnaOdleglosc[0]->operator[](i) = true;
-                                    }
-                                }
-                                else
-                                {
-                                    if (aadOdleglosciParts[ i ][ iIndex[1] ] == dMinimum)
-                                    {
-                                        apvbCzyMinimalnaOdleglosc[1]->operator[](i) = true;
-                                    }
-                                }
-                            }
-                        }
-
-                        // a teraz - po znalezieniu potencjalnych elementow do dopasowania
-                        // dopasowujemy pierwszy z potencjalnych
-                        iDopasowywany = -1;
-                        for (i = 0; i < aiRozmiarCalychGrup[ 1 - iZDrugim ]; i++)
-                        {
-                            if (apvbCzyMinimalnaOdleglosc[iZDrugim]->operator[](i))
-                            {
-                                iDopasowywany = i;
-                                break;
-                            }
-                        }
-                        // musielismy znalezc jakiegos dopasowywanego
-                        assert((iDopasowywany >= 0) &&
-                               (iDopasowywany < aiRozmiarCalychGrup[ 1 - iZDrugim ]));
-
-                        // no to juz mozemy dopasowac
-                        m_pMatching->Match(
-                                           iZDrugim,
-                                           aiKoniecPierwszejGrupy[ iZDrugim ] + iIndex[ iZDrugim ],
-                                           1 - iZDrugim,
-                                           aiKoniecPierwszejGrupy[ 1 - iZDrugim ] + iDopasowywany);
-                        DB(printf("Przypadek 2.1.: dopasowane Parts dopasowaniebz drugim: (%2i, %2i)\n", aiKoniecPierwszejGrupy[ iZDrugim ] + iIndex[ iZDrugim ], aiKoniecPierwszejGrupy[ 1 - iZDrugim ] + iDopasowywany);)
-
-                        //aiKoniecPierwszejGrupy[ 1-iBezDrugiego ] + iDopasowywany ;)
-                        //aiKoniecPierwszejGrupy[ 1-iBezDrugiego ] + iDopasowywany ;)
-                        // zmniejsz liczby niedopasowanych elementow w grupach
-                        aiRozmiarGrupy[0]--;
-                        aiRozmiarGrupy[1]--;
-
-                    }
-                    else
-                    {
-                        // jedna z grup sie juz wyczerpala
-                        // wiec nie ma mozliwosci dopasowania tego drugiego Partu
-                        /// i trzeba poczekac na zmiane grupy
-                    }
-
-                    DB(printf("Przypadek 2.\n");)
-
-                }// PRZYPADEK 2.
-                else
-                {
-                    // PRZYPADEK 3. Zaden z Parts nie ma na liscie drugiego
-                    // AKCJA. Niezalezne dopasowanie obu Parts do pierwszych ze swojej listy
-
-                    // najpierw dopasujemy do iIndex[0] w organizmie 0
-                    int iDopasowywany = -1;
-                    // poszukujemy pierwszego z listy dopasowania - w organizmie 1
-                    for (i = 0; i < aiRozmiarCalychGrup[1]; i++)
-                    {
-                        if (apvbCzyMinimalnaOdleglosc[0]->operator[](i))
-                        {
-                            iDopasowywany = i;
-                            break;
-                        }
-                    }
-                    // musielismy znalezc jakiegos dopasowywanego
-                    assert((iDopasowywany >= 0) &&
-                           (iDopasowywany < aiRozmiarCalychGrup[1]));
-
-                    // teraz wlasnie dopasowujemy
-                    m_pMatching->Match(
-                                       0,
-                                       aiKoniecPierwszejGrupy[0] + iIndex[0],
-                                       1,
-                                       aiKoniecPierwszejGrupy[1] + iDopasowywany);
-
-                    // zmniejszamy liczbe niedopasowanych Parts
-                    aiRozmiarGrupy[0]--;
-                    aiRozmiarGrupy[1]--;
-
-                    // debug - dopasowanie
-                    DB(printf("Przypadek 3.: dopasowane Parts: (%2i, %2i)\n", aiKoniecPierwszejGrupy[0]
-                              + iIndex[0], aiKoniecPierwszejGrupy[1] + iDopasowywany);)
-
-                            // teraz dopasowujemy do iIndex[1] w organizmie 1
-                            iDopasowywany = -1;
-                    // poszukujemy pierwszego z listy dopasowania - w organizmie 0
-                    for (i = 0; i < aiRozmiarCalychGrup[0]; i++)
-                    {
-                        if (apvbCzyMinimalnaOdleglosc[1]->operator[](i))
-                        {
-                            iDopasowywany = i;
-                            break;
-                        }
-                    }
-                    // musielismy znalezc jakiegos dopasowywanego
-                    assert((iDopasowywany >= 0) &&
-                           (iDopasowywany < aiRozmiarCalychGrup[0]));
-
-                    // no i teraz realizujemy dopasowanie
-                    m_pMatching->Match(
-                                       0,
-                                       aiKoniecPierwszejGrupy[0] + iDopasowywany,
-                                       1,
-                                       aiKoniecPierwszejGrupy[1] + iIndex[1]);
-
-                    // zmniejszamy liczbe niedopasowanych Parts
-                    aiRozmiarGrupy[0]--;
-                    aiRozmiarGrupy[1]--;
-
-                    // debug - dopasowanie
-                    DB(printf("Przypadek 3.: dopasowane Parts: (%2i, %2i)\n", aiKoniecPierwszejGrupy[0]
-                              + iDopasowywany, aiKoniecPierwszejGrupy[1] + iIndex[1]);)
-
-
-                } // PRZYPADEK 3.
-
-            }// if (! bCzyKoniecGrupy)
-            else
-            {
-                // gdy mamy już koniec grup - musimy zlikwidować tablicę aadOdleglosciParts
-                // bo za chwilke skonczy sie nam petla
-                for (i = 0; i < aiRozmiarCalychGrup[0]; i++)
-                {
-                    SAFEDELETEARRAY(aadOdleglosciParts[i]);
-                }
-                SAFEDELETEARRAY(aadOdleglosciParts);
-
-                // musimy tez usunac tablice (wektory) mozliwosci dopasowania
-                SAFEDELETE(apvbCzyMinimalnaOdleglosc[0]);
-                SAFEDELETE(apvbCzyMinimalnaOdleglosc[1]);
-            }
-        } // while (! bCzyKoniecGrupy)
-
-        // PO DOPASOWANIU WSZYSTKIEGO Z GRUP (CO NAJMNIEJ JEDNEJ GRUPY W CAŁOŚCI)
-
-        // gdy rozmiar ktorejkolwiek z grup dopasowania spadl do zera
-        // to musimy przesunac KoniecPierwszejGrupy (wszystkie dopasowane)
-        for (i = 0; i < 2; i++)
-        {
-            // grupy nie moga miec mniejszego niz 0 rozmiaru
-            assert(aiRozmiarGrupy[i] >= 0);
-            if (aiRozmiarGrupy[i] == 0)
-                aiKoniecPierwszejGrupy[i] = aiKoniecGrupyDopasowania[i];
-        }
-
-        // sprawdzenie warunku konca dopasowywania - gdy nie
-        // ma juz w jakims organizmie co dopasowywac
-        if (aiKoniecPierwszejGrupy[0] >= m_aiPartCount[0] ||
-                aiKoniecPierwszejGrupy[1] >= m_aiPartCount[1])
-        {
-            iCzyDopasowane = 1;
-        }
-    } // koniec WHILE - petli dopasowania
+	// uniwersalne liczniki
+	int i, j;
+
+	assert(m_pMatching != NULL);
+	assert(m_pMatching->IsEmpty() == true);
+
+	// rozpoczynamy etap dopasowywania Parts w organizmach
+	// czy dopasowano już wszystkie Parts?
+	int iCzyDopasowane = 0;
+	// koniec grupy aktualnie dopasowywanej w każdym organizmie
+	int aiKoniecGrupyDopasowania[2] = { 0, 0 };
+	// koniec grupy już w całości dopasowanej
+	// (Pomiedzy tymi dwoma indeksami znajduja sie Parts w tablicy
+	// m_aDegrees, ktore moga byc dopasowywane (tam nadal moga
+	// byc tez dopasowane - ale nie musi to byc w sposob
+	// ciagly)
+	int aiKoniecPierwszejGrupy[2] = { 0, 0 };
+	// Tablica przechowująca odległości poszczególnych Parts z aktualnych
+	// grup dopasowania. Rozmiar - prostokąt o bokach równych liczbie elementów w 
+	// dopasowywanych aktualnie grupach. Pierwszy wymiar - pierwszy organizm.
+	// Drugi wymiar - drugi organizm (nie zależy to od tego, który jest mniejszy).
+	// Wliczane w rozmiar tablicy są nawet już dopasowane elementy - tablice
+	// paiCzyDopasowany pamiętają stan dopasowania tych elementów.
+	typedef double *TPDouble;
+	double **aadOdleglosciParts;
+	// dwie tablice okreslajace Parts, ktore moga byc do siebie dopasowywane
+	// rozmiary: [0] - aiRozmiarCalychGrup[1]
+	//			 [1] - aiRozmiarCalychGrup[0]
+	std::vector<bool> *apvbCzyMinimalnaOdleglosc[2];
+	// rozmiar aktualnie dopasowywanej grupy w odpowiednim organizmie (tylko elementy
+	// jeszcze niedopasowane).
+	int aiRozmiarGrupy[2];
+	// rozmiar aktualnie dopasowywanych grup w odpowiednim organizmie (włączone są
+	// w to również elementy już dopasowane).
+	int aiRozmiarCalychGrup[2] = { 0, 0 };
+
+	// utworzenie tablicy rozmiarow
+	for (i = 0; i < 2; i++)
+	{
+		m_aiPartCount[i] = m_Mod[i]->getPartCount();
+	}
+
+	// DOPASOWYWANIE PARTS
+	while (!iCzyDopasowane)
+	{
+		// znajdz konce obu grup aktualnie dopasowywanych w obu organizmach
+		for (i = 0; i < 2; i++)
+		{
+			// czyli poszukaj miejsca zmiany stopnia lub konca tablicy
+			for (j = aiKoniecPierwszejGrupy[i] + 1; j < m_aiPartCount[i]; j++)
+			{
+				if (m_aDegrees[i][j][DEGREE] < m_aDegrees[i][j - 1][DEGREE])
+				{
+					break;
+				}
+			}
+			aiKoniecGrupyDopasowania[i] = j;
+
+			// sprawdz poprawnosc tego indeksu
+			assert((aiKoniecGrupyDopasowania[i] > 0) &&
+				(aiKoniecGrupyDopasowania[i] <= m_aiPartCount[i]));
+
+			// oblicz rozmiary całych grup - łącznie z dopasowanymi już elementami
+			aiRozmiarCalychGrup[i] = aiKoniecGrupyDopasowania[i] -
+				aiKoniecPierwszejGrupy[i];
+
+			// sprawdz teraz rozmiar tej grupy w sensie liczby niedopasowanzch
+			// nie moze to byc puste!
+			aiRozmiarGrupy[i] = 0;
+			for (j = aiKoniecPierwszejGrupy[i]; j < aiKoniecGrupyDopasowania[i]; j++)
+			{
+				// od poczatku do konca grupy
+				if (!m_pMatching->IsMatched(i, j))
+				{
+					// jesli niedopasowany, to zwieksz licznik
+					aiRozmiarGrupy[i]++;
+				}
+			}
+			// grupa nie moze byc pusta!
+			assert(aiRozmiarGrupy[i] > 0);
+		}
+
+		// DOPASOWYWANIE PARTS Z GRUP
+
+		// stworzenie tablicy odległości lokalnych
+		// stwórz pierwszy wymiar - wg rozmiaru zerowego organizmu
+		aadOdleglosciParts = new TPDouble[aiRozmiarCalychGrup[0]];
+		assert(aadOdleglosciParts != NULL);
+		// stwórz drugi wymiar - wg rozmiaru drugiego organizmu
+		for (i = 0; i < aiRozmiarCalychGrup[0]; i++)
+		{
+			aadOdleglosciParts[i] = new double[aiRozmiarCalychGrup[1]];
+			assert(aadOdleglosciParts[i] != NULL);
+		}
+
+		// stworzenie tablic mozliwosci dopasowania (indykatorow minimalnej odleglosci)
+		apvbCzyMinimalnaOdleglosc[0] = new std::vector<bool>(aiRozmiarCalychGrup[1], false);
+		apvbCzyMinimalnaOdleglosc[1] = new std::vector<bool>(aiRozmiarCalychGrup[0], false);
+		// sprawdz stworzenie tablic
+		assert(apvbCzyMinimalnaOdleglosc[0] != NULL);
+		assert(apvbCzyMinimalnaOdleglosc[1] != NULL);
+
+		// wypełnienie elementów macierzy (i,j) odległościami pomiędzy
+		// odpowiednimi Parts: (i) w organizmie 0 i (j) w organizmie 1.
+		// UWAGA! Uwzględniamy tylko te Parts, które nie są jeszcze dopasowane
+		// (reszta to byłaby po prostu strata czasu).
+		int iDeg, iNeu; // ilościowe określenie różnic stopnia, liczby neuronów i połączeń Parts
+		//int iNIt;
+		double dGeo; // ilościowe określenie różnic geometrycznych pomiędzy Parts
+		// indeksy konkretnych Parts - indeksy sa ZERO-BASED, choć właściwy dostep
+		// do informacji o Part wymaga dodania aiKoniecPierwszejGrupy[]
+		// tylko aadOdleglosciParts[][] indeksuje sie bezposrednio zawartoscia iIndex[]
+		int iIndex[2];
+		int iPartIndex[2] = { -1, -1 }; // at [iModel]: original index of a Part for the specified model (iModel)
+
+		// debug - wypisz zakres dopasowywanych indeksow
+		DB(printf("Organizm 0: grupa: (%2i, %2i)\n", aiKoniecPierwszejGrupy[0],
+			aiKoniecGrupyDopasowania[0]);)
+			DB(printf("Organizm 1: grupa: (%2i, %2i)\n", aiKoniecPierwszejGrupy[1],
+			aiKoniecGrupyDopasowania[1]);)
+
+			for (i = 0; i < aiRozmiarCalychGrup[0]; i++)
+			{
+
+			// iterujemy i - Parts organizmu 0
+			// (indeks podstawowy - aiKoniecPierwszejGrupy[0])
+
+			if (!(m_pMatching->IsMatched(0, aiKoniecPierwszejGrupy[0] + i)))
+			{
+				// interesuja nas tylko te niedopasowane jeszcze (i)
+				for (j = 0; j < aiRozmiarCalychGrup[1]; j++)
+				{
+
+					// iterujemy j - Parts organizmu 1
+					// (indeks podstawowy - aiKoniecPierwszejGrupy[1])
+
+					if (!(m_pMatching->IsMatched(1, aiKoniecPierwszejGrupy[1] + j)))
+					{
+						// interesuja nas tylko te niedopasowane jeszcze (j)
+						// teraz obliczymy lokalne różnice pomiędzy Parts
+						iDeg = abs(m_aDegrees[0][aiKoniecPierwszejGrupy[0] + i][1]
+							- m_aDegrees[1][aiKoniecPierwszejGrupy[1] + j][1]);
+
+						//iNit currently is not a component of distance measure            
+						//iNIt = abs(m_aDegrees[0][ aiKoniecPierwszejGrupy[0] + i ][2]
+						//           - m_aDegrees[1][ aiKoniecPierwszejGrupy[1] + j ][2]);
+
+						iNeu = abs(m_aDegrees[0][aiKoniecPierwszejGrupy[0] + i][3]
+							- m_aDegrees[1][aiKoniecPierwszejGrupy[1] + j][3]);
+
+						// obliczenie także lokalnych różnic geometrycznych pomiędzy Parts
+						// find original indices of Parts for both of the models
+						iPartIndex[0] = m_aDegrees[0][aiKoniecPierwszejGrupy[0] + i][0];
+						iPartIndex[1] = m_aDegrees[1][aiKoniecPierwszejGrupy[1] + j][0];
+						// now compute the geometrical distance of these Parts (use m_aPositions
+						// which should be computed by SVD)
+						Pt3D Part0Pos(m_aPositions[0][iPartIndex[0]]);
+						Pt3D Part1Pos(m_aPositions[1][iPartIndex[1]]);
+						dGeo = m_adFactors[3] == 0 ? 0 : Part0Pos.distanceTo(Part1Pos); //no need to compute distane when m_dDG weight is 0
+
+						// tutaj prawdopodobnie należy jeszcze dodać sprawdzanie
+						// identyczności pozostałych własności (oprócz geometrii)
+						// - żeby móc stwierdzić w ogóle identyczność Parts
+
+						// i ostateczna odleglosc indukowana przez te roznice
+						// (tutaj nie ma różnicy w liczbie wszystkich wierzchołków)
+						aadOdleglosciParts[i][j] = m_adFactors[1] * double(iDeg) +
+							m_adFactors[2] * double(iNeu) +
+							m_adFactors[3] * dGeo;
+						DB(printf("Parts Distance (%2i,%2i) = %.3lf\n", aiKoniecPierwszejGrupy[0] + i,
+							aiKoniecPierwszejGrupy[1] + j, aadOdleglosciParts[i][j]);)
+							DB(printf("Parts geometrical distance = %.20lf\n", dGeo);)
+							DB(printf("Pos0: (%.3lf %.3lf %.3lf)\n", Part0Pos.x, Part0Pos.y, Part0Pos.z);)
+							DB(printf("Pos1: (%.3lf %.3lf %.3lf)\n", Part1Pos.x, Part1Pos.y, Part1Pos.z);)
+					}
+				}
+			}
+			}
+
+		// tutaj - sprawdzic tylko, czy tablica odleglosci lokalnych jest poprawnie obliczona
+
+		// WYKORZYSTANIE TABLICY ODLEGLOSCI DO BUDOWY DOPASOWANIA
+
+		// trzeba raczej iterować aż do zebrania wszystkich możliwych dopasowań w grupie
+		// dlatego wprowadzamy dodatkowa zmienna - czy skonczyla sie juz grupa
+		bool bCzyKoniecGrupy = false;
+		while (!bCzyKoniecGrupy)
+		{
+			for (i = 0; i < 2; i++)
+			{
+				// iterujemy (i) po organizmach
+				// szukamy najpierw jakiegoś niedopasowanego jeszcze Part w organizmach
+
+				// zakładamy, że nie ma takiego Part
+				iIndex[i] = -1;
+
+				for (j = 0; j < aiRozmiarCalychGrup[i]; j++)
+				{
+					// iterujemy (j) - Parts organizmu (i)
+					// (indeks podstawowy - aiKoniecPierwszejGrupy[0])
+					if (!(m_pMatching->IsMatched(i, aiKoniecPierwszejGrupy[i] + j)))
+					{
+						// gdy mamy w tej grupie jakis niedopasowany element, to ustawiamy
+						// iIndex[i] (chcemy w zasadzie pierwszy taki)
+						iIndex[i] = j;
+						break;
+					}
+				}
+
+				// sprawdzamy, czy w ogole znaleziono taki Part
+				if (iIndex[i] < 0)
+				{
+					// gdy nie znaleziono takiego Part - mamy koniec dopasowywania w
+					// tych grupach
+					bCzyKoniecGrupy = true;
+				}
+				// sprawdz poprawnosc indeksu niedopasowanego Part - musi byc w aktualnej grupie
+				assert((iIndex[i] >= -1) && (iIndex[i] < aiRozmiarCalychGrup[i]));
+			}
+
+
+			// teraz mamy sytuacje:
+			// - mamy w iIndex[0] i iIndex[1] indeksy pierwszych niedopasowanych Part
+			//		w organizmach, albo
+			// - nie ma w ogóle już czego dopasowywać (należy przejść do innej grupy)
+			if (!bCzyKoniecGrupy)
+			{
+				// gdy nie ma jeszcze końca żadnej z grup - możemy dopasowywać
+				// najpierw wyszukujemy w tablicy minimum odległości od tych
+				// wyznaczonych Parts
+
+				// najpierw wyczyscimy wektory potencjalnych dopasowan
+				// dla organizmu 1 (o rozmiarze grupy z 0)
+				for (i = 0; i < aiRozmiarCalychGrup[0]; i++)
+				{
+					apvbCzyMinimalnaOdleglosc[1]->operator[](i) = false;
+				}
+				// dla organizmu 0 (o rozmiarze grup z 1)
+				for (i = 0; i < aiRozmiarCalychGrup[1]; i++)
+				{
+					apvbCzyMinimalnaOdleglosc[0]->operator[](i) = false;
+				}
+
+				// szukanie minimum dla Part o indeksie iIndex[0] w organizmie 0
+				// wsrod niedopasowanych Parts z organizmu 1
+				// zakładamy, że nie znaleliśmy jeszcze minimum
+				double dMinimum = HUGE_VAL;
+				for (i = 0; i < aiRozmiarCalychGrup[1]; i++)
+				{
+					if (!(m_pMatching->IsMatched(1, aiKoniecPierwszejGrupy[1] + i)))
+					{
+
+						// szukamy minimum obliczonej lokalnej odleglosci tylko wsrod
+						// niedopasowanych jeszcze Parts
+						if (aadOdleglosciParts[iIndex[0]][i] < dMinimum)
+						{
+							dMinimum = aadOdleglosciParts[iIndex[0]][i];
+						}
+
+						// przy okazji - sprawdz, czy HUGE_VAL jest rzeczywiscie max dla double
+						assert(aadOdleglosciParts[iIndex[0]][i] < HUGE_VAL);
+					}
+				}
+				// sprawdz, czy minimum znaleziono - musi takie byc, bo jest cos niedopasowanego
+				assert((dMinimum >= 0.0) && (dMinimum < HUGE_VAL));
+
+				// teraz zaznaczamy w tablicy te wszystkie Parts, ktore maja
+				// rzeczywiscie te minimalna odleglosc do Part iIndex[0] w organizmie 0
+				for (i = 0; i < aiRozmiarCalychGrup[1]; i++)
+				{
+					if (!(m_pMatching->IsMatched(1, aiKoniecPierwszejGrupy[1] + i)))
+					{
+						if (aadOdleglosciParts[iIndex[0]][i] == dMinimum)
+						{
+							// jesli w danym miejscu tablicy odleglosci jest faktyczne
+							// minimum odleglosci, to mamy potencjalna pare dla iIndex[0]
+							apvbCzyMinimalnaOdleglosc[0]->operator[](i) = true;
+						}
+
+						// sprawdz poprawnosc znalezionego wczesniej minimum
+						assert(aadOdleglosciParts[iIndex[0]][i] >= dMinimum);
+					}
+				}
+
+				// podobnie szukamy minimum dla Part o indeksie iIndex[1] w organizmie 1
+				// wsrod niedopasowanych Parts z organizmu 0
+				dMinimum = HUGE_VAL;
+				for (i = 0; i < aiRozmiarCalychGrup[0]; i++)
+				{
+					if (!(m_pMatching->IsMatched(0, aiKoniecPierwszejGrupy[0] + i)))
+					{
+						// szukamy minimum obliczonej lokalnej odleglosci tylko wsrod
+						// niedopasowanych jeszcze Parts
+						if (aadOdleglosciParts[i][iIndex[1]] < dMinimum)
+						{
+							dMinimum = aadOdleglosciParts[i][iIndex[1]];
+						}
+						// przy okazji - sprawdz, czy HUGE_VAL jest rzeczywiscie max dla double
+						assert(aadOdleglosciParts[i][iIndex[1]] < HUGE_VAL);
+					}
+				}
+				// sprawdz, czy minimum znaleziono - musi takie byc, bo jest cos niedopasowanego
+				assert((dMinimum >= 0.0) && (dMinimum < HUGE_VAL));
+
+				// teraz zaznaczamy w tablicy te wszystkie Parts, ktore maja
+				// rzeczywiscie te minimalne odleglosci do Part iIndex[1] w organizmie 1
+				for (i = 0; i < aiRozmiarCalychGrup[0]; i++)
+				{
+					if (!(m_pMatching->IsMatched(0, aiKoniecPierwszejGrupy[0] + i)))
+					{
+						if (aadOdleglosciParts[i][iIndex[1]] == dMinimum)
+						{
+							// jesli w danym miejscu tablicy odleglosci jest faktyczne
+							// minimum odleglosci, to mamy potencjalna pare dla iIndex[1]
+							apvbCzyMinimalnaOdleglosc[1]->operator[](i) = true;
+						}
+
+						// sprawdz poprawnosc znalezionego wczesniej minimum
+						assert(aadOdleglosciParts[i][iIndex[1]] >= dMinimum);
+					}
+				}
+
+				// teraz mamy juz poszukane potencjalne grupy dopasowania - musimy
+				// zdecydowac, co do czego dopasujemy!
+				// szukamy Part iIndex[0] posrod mozliwych do dopasowania dla Part iIndex[1]
+				// szukamy takze Part iIndex[1] posrod mozliwych do dopasowania dla Part iIndex[0]
+				bool PartZ1NaLiscie0 = apvbCzyMinimalnaOdleglosc[0]->operator[](iIndex[1]);
+				bool PartZ0NaLiscie1 = apvbCzyMinimalnaOdleglosc[1]->operator[](iIndex[0]);
+
+				if (PartZ1NaLiscie0 && PartZ0NaLiscie1)
+				{
+					// PRZYPADEK 1. Oba Parts maja sie wzajemnie na listach mozliwych
+					// dopasowan.
+					// AKCJA. Dopasowanie wzajemne do siebie.
+
+					m_pMatching->Match(0, aiKoniecPierwszejGrupy[0] + iIndex[0],
+						1, aiKoniecPierwszejGrupy[1] + iIndex[1]);
+
+					// zmniejsz liczby niedopasowanych elementow w grupach
+					aiRozmiarGrupy[0]--;
+					aiRozmiarGrupy[1]--;
+					// debug - co zostalo dopasowane
+					DB(printf("Przypadek 1.: dopasowane Parts: (%2i, %2i)\n", aiKoniecPierwszejGrupy[0]
+						+ iIndex[0], aiKoniecPierwszejGrupy[1] + iIndex[1]);)
+
+				}// PRZYPADEK 1.
+				else
+					if (PartZ1NaLiscie0 || PartZ0NaLiscie1)
+					{
+					// PRZYPADEK 2. Tylko jeden z Parts ma drugiego na swojej liscie
+					// mozliwych dopasowan
+					// AKCJA. Dopasowanie jednego jest proste (tego, ktory nie ma 
+					// na swojej liscie drugiego). Dla tego drugiego nalezy powtorzyc
+					// duza czesc obliczen (znalezc mu nowa mozliwa pare)
+
+					// indeks organizmu, ktorego Part nie ma dopasowywanego Part
+					// z drugiego organizmu na swojej liscie
+					int iBezDrugiego;
+
+					// okreslenie indeksu organizmu z dopasowywanym Part
+					if (!PartZ1NaLiscie0)
+					{
+						iBezDrugiego = 0;
+					}
+					else
+					{
+						iBezDrugiego = 1;
+					}
+					// sprawdz indeks organizmu
+					assert((iBezDrugiego == 0) || (iBezDrugiego == 1));
+
+					int iDopasowywany = -1;
+					// poszukujemy pierwszego z listy dopasowania
+					for (i = 0; i < aiRozmiarCalychGrup[1 - iBezDrugiego]; i++)
+					{
+						if (apvbCzyMinimalnaOdleglosc[iBezDrugiego]->operator[](i))
+						{
+							iDopasowywany = i;
+							break;
+						}
+					}
+					// sprawdz poprawnosc indeksu dopasowywanego (musimy cos znalezc!)
+					// nieujemny i w odpowiedniej grupie!
+					assert((iDopasowywany >= 0) &&
+						(iDopasowywany < aiRozmiarCalychGrup[1 - iBezDrugiego]));
+
+					// znalezlismy 1. Part z listy dopasowania - dopasowujemy!
+					m_pMatching->Match(
+						iBezDrugiego,
+						aiKoniecPierwszejGrupy[iBezDrugiego] + iIndex[iBezDrugiego],
+						1 - iBezDrugiego,
+						aiKoniecPierwszejGrupy[1 - iBezDrugiego] + iDopasowywany);
+					DB(printf("Przypadek 2.1.: dopasowane Parts dopasowanie bez drugiego: (%2i, %2i)\n", aiKoniecPierwszejGrupy[iBezDrugiego] + iIndex[iBezDrugiego],
+						aiKoniecPierwszejGrupy[1 - iBezDrugiego] + iDopasowywany);)
+
+						// zmniejsz liczby niedopasowanych elementow w grupach
+						aiRozmiarGrupy[0]--;
+					aiRozmiarGrupy[1]--;
+
+					// sprawdz, czy jest szansa dopasowania tego Part z drugiej strony
+					// (ktora miala mozliwosc dopasowania tego Part z poprzedniego organizmu)
+					if ((aiRozmiarGrupy[0] > 0) && (aiRozmiarGrupy[1] > 0))
+					{
+						// jesli grupy sie jeszcze nie wyczrpaly
+						// to jest mozliwosc dopasowania w organizmie
+
+						int iZDrugim = 1 - iBezDrugiego;
+						// sprawdz indeks organizmu
+						assert((iZDrugim == 0) || (iZDrugim == 1));
+
+						// bedziemy szukac minimum wsrod niedopasowanych - musimy wykasowac
+						// poprzednie obliczenia minimum
+						// dla organizmu 1 (o rozmiarze grupy z 0)
+						for (i = 0; i < aiRozmiarCalychGrup[0]; i++)
+						{
+							apvbCzyMinimalnaOdleglosc[1]->operator[](i) = false;
+						}
+						// dla organizmu 0 (o rozmiarze grup z 1)
+						for (i = 0; i < aiRozmiarCalychGrup[1]; i++)
+						{
+							apvbCzyMinimalnaOdleglosc[0]->operator[](i) = false;
+						}
+
+						// szukamy na nowo minimum dla Part o indeksie iIndex[ iZDrugim ] w organizmie iZDrugim
+						// wsrod niedopasowanych Parts z organizmu 1 - iZDrugim
+						dMinimum = HUGE_VAL;
+						for (i = 0; i < aiRozmiarCalychGrup[1 - iZDrugim]; i++)
+						{
+							if (!(m_pMatching->IsMatched(
+								1 - iZDrugim,
+								aiKoniecPierwszejGrupy[1 - iZDrugim] + i)))
+							{
+								// szukamy minimum obliczonej lokalnej odleglosci tylko wsrod
+								// niedopasowanych jeszcze Parts
+								if (iZDrugim == 0)
+								{
+									// teraz niestety musimy rozpoznac odpowiedni organizm
+									// zeby moc indeksowac niesymetryczna tablice
+									if (aadOdleglosciParts[iIndex[0]][i] < dMinimum)
+									{
+										dMinimum = aadOdleglosciParts[iIndex[0]][i];
+									}
+									// przy okazji - sprawdz, czy HUGE_VAL jest rzeczywiscie max dla double
+									assert(aadOdleglosciParts[iIndex[0]][i] < HUGE_VAL);
+
+								}
+								else
+								{
+									if (aadOdleglosciParts[i][iIndex[1]] < dMinimum)
+									{
+										dMinimum = aadOdleglosciParts[i][iIndex[1]];
+									}
+									// przy okazji - sprawdz, czy HUGE_VAL jest rzeczywiscie max dla double
+									assert(aadOdleglosciParts[i][iIndex[1]] < HUGE_VAL);
+								}
+							}
+						}
+						// sprawdz, czy minimum znaleziono - musi takie byc, bo jest cos niedopasowanego
+						assert((dMinimum >= 0.0) && (dMinimum < HUGE_VAL));
+
+						// teraz zaznaczamy w tablicy te wszystkie Parts, ktore maja
+						// rzeczywiscie te minimalne odleglosci do Part w organizmie iZDrugim
+						for (i = 0; i < aiRozmiarCalychGrup[1 - iZDrugim]; i++)
+						{
+							if (!(m_pMatching->IsMatched(
+								1 - iZDrugim,
+								aiKoniecPierwszejGrupy[1 - iZDrugim] + i)))
+							{
+								if (iZDrugim == 0)
+								{
+									// teraz niestety musimy rozpoznac odpowiedni organizm
+									// zeby moc indeksowac niesymetryczna tablice
+									if (aadOdleglosciParts[iIndex[0]][i] == dMinimum)
+									{
+										// jesli w danym miejscu tablicy odleglosci jest faktyczne 
+										// minimum odleglosci, to mamy potencjalna pare dla iIndex[1]
+										apvbCzyMinimalnaOdleglosc[0]->operator[](i) = true;
+									}
+								}
+								else
+								{
+									if (aadOdleglosciParts[i][iIndex[1]] == dMinimum)
+									{
+										apvbCzyMinimalnaOdleglosc[1]->operator[](i) = true;
+									}
+								}
+							}
+						}
+
+						// a teraz - po znalezieniu potencjalnych elementow do dopasowania
+						// dopasowujemy pierwszy z potencjalnych
+						iDopasowywany = -1;
+						for (i = 0; i < aiRozmiarCalychGrup[1 - iZDrugim]; i++)
+						{
+							if (apvbCzyMinimalnaOdleglosc[iZDrugim]->operator[](i))
+							{
+								iDopasowywany = i;
+								break;
+							}
+						}
+						// musielismy znalezc jakiegos dopasowywanego
+						assert((iDopasowywany >= 0) &&
+							(iDopasowywany < aiRozmiarCalychGrup[1 - iZDrugim]));
+
+						// no to juz mozemy dopasowac
+						m_pMatching->Match(
+							iZDrugim,
+							aiKoniecPierwszejGrupy[iZDrugim] + iIndex[iZDrugim],
+							1 - iZDrugim,
+							aiKoniecPierwszejGrupy[1 - iZDrugim] + iDopasowywany);
+						DB(printf("Przypadek 2.1.: dopasowane Parts dopasowaniebz drugim: (%2i, %2i)\n", aiKoniecPierwszejGrupy[iZDrugim] + iIndex[iZDrugim], aiKoniecPierwszejGrupy[1 - iZDrugim] + iDopasowywany);)
+
+							//aiKoniecPierwszejGrupy[ 1-iBezDrugiego ] + iDopasowywany ;)
+							//aiKoniecPierwszejGrupy[ 1-iBezDrugiego ] + iDopasowywany ;)
+							// zmniejsz liczby niedopasowanych elementow w grupach
+							aiRozmiarGrupy[0]--;
+						aiRozmiarGrupy[1]--;
+
+					}
+					else
+					{
+						// jedna z grup sie juz wyczerpala
+						// wiec nie ma mozliwosci dopasowania tego drugiego Partu
+						/// i trzeba poczekac na zmiane grupy
+					}
+
+					DB(printf("Przypadek 2.\n");)
+
+					}// PRZYPADEK 2.
+					else
+					{
+						// PRZYPADEK 3. Zaden z Parts nie ma na liscie drugiego
+						// AKCJA. Niezalezne dopasowanie obu Parts do pierwszych ze swojej listy
+
+						// najpierw dopasujemy do iIndex[0] w organizmie 0
+						int iDopasowywany = -1;
+						// poszukujemy pierwszego z listy dopasowania - w organizmie 1
+						for (i = 0; i < aiRozmiarCalychGrup[1]; i++)
+						{
+							if (apvbCzyMinimalnaOdleglosc[0]->operator[](i))
+							{
+								iDopasowywany = i;
+								break;
+							}
+						}
+						// musielismy znalezc jakiegos dopasowywanego
+						assert((iDopasowywany >= 0) &&
+							(iDopasowywany < aiRozmiarCalychGrup[1]));
+
+						// teraz wlasnie dopasowujemy
+						m_pMatching->Match(
+							0,
+							aiKoniecPierwszejGrupy[0] + iIndex[0],
+							1,
+							aiKoniecPierwszejGrupy[1] + iDopasowywany);
+
+						// zmniejszamy liczbe niedopasowanych Parts
+						aiRozmiarGrupy[0]--;
+						aiRozmiarGrupy[1]--;
+
+						// debug - dopasowanie
+						DB(printf("Przypadek 3.: dopasowane Parts: (%2i, %2i)\n", aiKoniecPierwszejGrupy[0]
+							+ iIndex[0], aiKoniecPierwszejGrupy[1] + iDopasowywany);)
+
+							// teraz dopasowujemy do iIndex[1] w organizmie 1
+							iDopasowywany = -1;
+						// poszukujemy pierwszego z listy dopasowania - w organizmie 0
+						for (i = 0; i < aiRozmiarCalychGrup[0]; i++)
+						{
+							if (apvbCzyMinimalnaOdleglosc[1]->operator[](i))
+							{
+								iDopasowywany = i;
+								break;
+							}
+						}
+						// musielismy znalezc jakiegos dopasowywanego
+						assert((iDopasowywany >= 0) &&
+							(iDopasowywany < aiRozmiarCalychGrup[0]));
+
+						// no i teraz realizujemy dopasowanie
+						m_pMatching->Match(
+							0,
+							aiKoniecPierwszejGrupy[0] + iDopasowywany,
+							1,
+							aiKoniecPierwszejGrupy[1] + iIndex[1]);
+
+						// zmniejszamy liczbe niedopasowanych Parts
+						aiRozmiarGrupy[0]--;
+						aiRozmiarGrupy[1]--;
+
+						// debug - dopasowanie
+						DB(printf("Przypadek 3.: dopasowane Parts: (%2i, %2i)\n", aiKoniecPierwszejGrupy[0]
+							+ iDopasowywany, aiKoniecPierwszejGrupy[1] + iIndex[1]);)
+
+
+					} // PRZYPADEK 3.
+
+			}// if (! bCzyKoniecGrupy)
+			else
+			{
+				// gdy mamy już koniec grup - musimy zlikwidować tablicę aadOdleglosciParts
+				// bo za chwilke skonczy sie nam petla
+				for (i = 0; i < aiRozmiarCalychGrup[0]; i++)
+				{
+					SAFEDELETEARRAY(aadOdleglosciParts[i]);
+				}
+				SAFEDELETEARRAY(aadOdleglosciParts);
+
+				// musimy tez usunac tablice (wektory) mozliwosci dopasowania
+				SAFEDELETE(apvbCzyMinimalnaOdleglosc[0]);
+				SAFEDELETE(apvbCzyMinimalnaOdleglosc[1]);
+			}
+		} // while (! bCzyKoniecGrupy)
+
+		// PO DOPASOWANIU WSZYSTKIEGO Z GRUP (CO NAJMNIEJ JEDNEJ GRUPY W CAŁOŚCI)
+
+		// gdy rozmiar ktorejkolwiek z grup dopasowania spadl do zera
+		// to musimy przesunac KoniecPierwszejGrupy (wszystkie dopasowane)
+		for (i = 0; i < 2; i++)
+		{
+			// grupy nie moga miec mniejszego niz 0 rozmiaru
+			assert(aiRozmiarGrupy[i] >= 0);
+			if (aiRozmiarGrupy[i] == 0)
+				aiKoniecPierwszejGrupy[i] = aiKoniecGrupyDopasowania[i];
+		}
+
+		// sprawdzenie warunku konca dopasowywania - gdy nie
+		// ma juz w jakims organizmie co dopasowywac
+		if (aiKoniecPierwszejGrupy[0] >= m_aiPartCount[0] ||
+			aiKoniecPierwszejGrupy[1] >= m_aiPartCount[1])
+		{
+			iCzyDopasowane = 1;
+		}
+	} // koniec WHILE - petli dopasowania
 }
 
 /** Matches Parts in both organisms so that computation of similarity is possible.
-    New algorithm (assures symmetry of the similarity measure) with geometry
-    taken into consideration.
-    Assumptions:
-    - Models (m_Mod) are created and available.
-        - Matching (m_pMatching) is created, but empty
-        Exit conditions:
-        - Matching (m_pMatching) is full
-        @return 1 if success, 0 otherwise
- */
+	New algorithm (assures symmetry of the similarity measure) with geometry
+	taken into consideration.
+	Assumptions:
+	- Models (m_Mod) are created and available.
+	- Matching (m_pMatching) is created, but empty
+	Exit conditions:
+	- Matching (m_pMatching) is full
+	@return 1 if success, 0 otherwise
+	*/
 int ModelSimil::MatchPartsGeometry()
 {
-    // zaloz, ze sa modele i sa poprawne
-    assert((m_Mod[0] != NULL) && (m_Mod[1] != NULL));
-    assert(m_Mod[0]->isValid() && m_Mod[1]->isValid());
-
-    if (!CreatePartInfoTables())
-        return 0;
-    if (!CountPartDegrees())
-        return 0;
-    if (!GetPartPositions())
-    {
-        return 0;
-    }
-    if (!CountPartNeurons())
-        return 0;
-
-
-    if (m_adFactors[3] > 0)
-    {
-        if (!ComputePartsPositionsBySVD())
-        {
-            return 0;
-        }
-    }
-
-    DB(printf("Przed sortowaniem:\n");)
-    DB(_PrintDegrees(0);)
-    DB(_PrintDegrees(1);)
-
-    if (!SortPartInfoTables())
-        return 0;
-
-    DB(printf("Po sortowaniu:\n");)
-    DB(_PrintDegrees(0);)
-    DB(_PrintDegrees(1);)
-
-    if (m_adFactors[3] > 0)
-    {
-        // tutaj zacznij pętlę po przekształceniach  geometrycznych
-        const int NO_OF_TRANSFORM = 8; // liczba transformacji geometrycznych (na razie tylko ID i O_YZ)
-        // tablice transformacji współrzędnych; nie są to dokładnie tablice tranformacji, ale raczej tablice PRZEJŚĆ
-        // pomiędzy transformacjami; 
-        // wartości orginalne transformacji dOrig uzyskuje się przez:
-        // for ( iTrans = 0; iTrans <= TRANS_INDEX; iTrans++ ) dOrig *= dMul[ iTrans ];
-        //const char *szTransformNames[NO_OF_TRANSFORM] = { "ID", "S_yz", "S_xz", "S_xy", "R180_z", "R180_y", "R180_z", "S_(0,0,0)" };
-        const int dMulX[ NO_OF_TRANSFORM ] = {1, -1, -1, 1, -1, 1, -1, -1};
-        const int dMulY[ NO_OF_TRANSFORM ] = {1, 1, -1, -1, -1, -1, -1, 1};
-        const int dMulZ[ NO_OF_TRANSFORM ] = {1, 1, 1, -1, -1, -1, 1, 1};
+	// zaloz, ze sa modele i sa poprawne
+	assert((m_Mod[0] != NULL) && (m_Mod[1] != NULL));
+	assert(m_Mod[0]->isValid() && m_Mod[1]->isValid());
+
+	if (!CreatePartInfoTables())
+		return 0;
+	if (!CountPartDegrees())
+		return 0;
+	if (!GetPartPositions())
+	{
+		return 0;
+	}
+	if (!CountPartNeurons())
+		return 0;
+
+
+	if (m_adFactors[3] > 0)
+	{
+		if (!ComputePartsPositionsBySVD())
+		{
+			return 0;
+		}
+	}
+
+	DB(printf("Przed sortowaniem:\n");)
+		DB(_PrintDegrees(0);)
+		DB(_PrintDegrees(1);)
+
+		if (!SortPartInfoTables())
+			return 0;
+
+	DB(printf("Po sortowaniu:\n");)
+		DB(_PrintDegrees(0);)
+		DB(_PrintDegrees(1);)
+
+		if (m_adFactors[3] > 0)
+		{
+		// tutaj zacznij pętlę po przekształceniach  geometrycznych
+		const int NO_OF_TRANSFORM = 8; // liczba transformacji geometrycznych (na razie tylko ID i O_YZ)
+		// tablice transformacji współrzędnych; nie są to dokładnie tablice tranformacji, ale raczej tablice PRZEJŚĆ
+		// pomiędzy transformacjami; 
+		// wartości orginalne transformacji dOrig uzyskuje się przez:
+		// for ( iTrans = 0; iTrans <= TRANS_INDEX; iTrans++ ) dOrig *= dMul[ iTrans ];
+		//const char *szTransformNames[NO_OF_TRANSFORM] = { "ID", "S_yz", "S_xz", "S_xy", "R180_z", "R180_y", "R180_z", "S_(0,0,0)" };
+		const int dMulX[NO_OF_TRANSFORM] = { 1, -1, -1, 1, -1, 1, -1, -1 };
+		const int dMulY[NO_OF_TRANSFORM] = { 1, 1, -1, -1, -1, -1, -1, 1 };
+		const int dMulZ[NO_OF_TRANSFORM] = { 1, 1, 1, -1, -1, -1, 1, 1 };
 
 #ifdef max
- #undef max //this macro would conflict with line below
+#undef max //this macro would conflict with line below
 #endif
-        double dMinSimValue = std::numeric_limits<double>::max(); // minimum value of similarity
-        int iMinSimTransform = -1; // index of the transformation with the minimum similarity
-        SimilMatching *pMinSimMatching = NULL; // matching with the minimum value of similarity
-
-        // remember the original positions of model 0 as computed by SVD in order to restore them later, after 
-        // all transformations have been computed
-        Pt3D *StoredPositions = NULL; // array of positions of Parts, for one (0th) model
-        // create the stored positions
-        StoredPositions = new Pt3D[ m_Mod[ 0 ]->getPartCount() ];
-        assert(StoredPositions != NULL);
-        // copy the original positions of model 0 (store them)
-        int iPart; // a counter of Parts
-        for (iPart = 0; iPart < m_Mod[ 0 ]->getPartCount(); iPart++)
-        {
-            StoredPositions[ iPart ].x = m_aPositions[ 0 ][ iPart ].x;
-            StoredPositions[ iPart ].y = m_aPositions[ 0 ][ iPart ].y;
-            StoredPositions[ iPart ].z = m_aPositions[ 0 ][ iPart ].z;
-        }
-        // now the original positions of model 0 are stored
-
-
-        int iTransform; // a counter of geometric transformations
-        for (iTransform = 0; iTransform < NO_OF_TRANSFORM; iTransform++)
-        {
-            // for each geometric transformation to be done
-            // entry conditions:
-            // - models (m_Mod) exist and are available
-            // - matching (m_pMatching) exists and is empty
-            // - all properties are created and available (m_aDegrees and m_aPositions)
-
-            // recompute geometric properties according to the transformation iTransform
-            // but only for model 0
-            for (iPart = 0; iPart < m_Mod[ 0 ]->getPartCount(); iPart++)
-            {
-                // for each iPart, a part of the model iMod
-                m_aPositions[ 0 ][ iPart ].x *= dMulX[ iTransform ];
-                m_aPositions[ 0 ][ iPart ].y *= dMulY[ iTransform ];
-                m_aPositions[ 0 ][ iPart ].z *= dMulZ[ iTransform ];
-            }
-            // now the positions are recomputed
-            ComputeMatching();
-
-            // teraz m_pMatching istnieje i jest pełne
-            assert(m_pMatching != NULL);
-            assert(m_pMatching->IsFull() == true);
-
-            // wykorzystaj to dopasowanie i geometrię do obliczenia tymczasowej wartości miary
-            int iTempRes = CountPartsDistance();
-            // załóż sukces
-            assert(iTempRes == 1);
-            double dCurrentSim = m_adFactors[0] * double(m_iDV) +
-                    m_adFactors[1] * double(m_iDD) +
-                    m_adFactors[2] * double(m_iDN) +
-                    m_adFactors[3] * double(m_dDG);
-            // załóż poprawną wartość podobieństwa
-            assert(dCurrentSim >= 0.0);
-
-            // porównaj wartość obliczoną z dotychczasowym minimum
-            if (dCurrentSim < dMinSimValue)
-            {
-                // jeśli uzyskano mniejszą wartość dopasowania, 
-                // to zapamiętaj to przekształcenie geometryczne i dopasowanie
-                dMinSimValue = dCurrentSim;
-                iMinSimTransform = iTransform;
-                SAFEDELETE(pMinSimMatching);
-                pMinSimMatching = new SimilMatching(*m_pMatching);
-                assert(pMinSimMatching != NULL);
-            }
-
-            // teraz już można usunąć stare dopasowanie (dla potrzeb następnego przebiegu pętli)
-            m_pMatching->Empty();
-        } // for ( iTransform )
-
-        // po pętli przywróć najlepsze dopasowanie
-        delete m_pMatching;
-        m_pMatching = pMinSimMatching;
-
-        DB(printf("Matching has been chosen!\n");)
-                // print the name of the chosen transformation:
-                // printf("Chosen transformation: %s\n", szTransformNames[ iMinSimTransform ] );
-
-                // i przywróć jednocześnie pozycje Parts modelu 0 dla tego dopasowania
-                // - najpierw przywroc Parts pozycje orginalne, po SVD
-        for (iPart = 0; iPart < m_Mod[ 0 ]->getPartCount(); iPart++)
-        {
-            m_aPositions[ 0 ][ iPart ].x = StoredPositions[ iPart ].x;
-            m_aPositions[ 0 ][ iPart ].y = StoredPositions[ iPart ].y;
-            m_aPositions[ 0 ][ iPart ].z = StoredPositions[ iPart ].z;
-        }
-        // - usun teraz zapamietane pozycje Parts
-        delete [] StoredPositions;
-        // - a teraz oblicz na nowo wspolrzedne wlasciwego przeksztalcenia dla model 0
-        for (iTransform = 0; iTransform <= iMinSimTransform; iTransform++)
-        {
-            // for each transformation before and INCLUDING iMinTransform
-            // do the transformation (only model 0)
-            for (iPart = 0; iPart < m_Mod[ 0 ]->getPartCount(); iPart++)
-            {
-                m_aPositions[ 0 ][ iPart ].x *= dMulX[ iTransform ];
-                m_aPositions[ 0 ][ iPart ].y *= dMulY[ iTransform ];
-                m_aPositions[ 0 ][ iPart ].z *= dMulZ[ iTransform ];
-            }
-        }
-
-    }
-    else
-    {
-        ComputeMatching();
-    }
-    // teraz dopasowanie musi byc pelne - co najmniej w jednym organizmie musza byc
-    // wszystkie elementy dopasowane
-    assert(m_pMatching->IsFull() == true);
-
-    //    _PrintDegrees(0);
-    //    _PrintDegrees(1);
-
-    DB(_PrintPartsMatching();)
-
-
-    return 1;
+		double dMinSimValue = std::numeric_limits<double>::max(); // minimum value of similarity
+		int iMinSimTransform = -1; // index of the transformation with the minimum similarity
+		SimilMatching *pMinSimMatching = NULL; // matching with the minimum value of similarity
+
+		// remember the original positions of model 0 as computed by SVD in order to restore them later, after 
+		// all transformations have been computed
+		Pt3D *StoredPositions = NULL; // array of positions of Parts, for one (0th) model
+		// create the stored positions
+		StoredPositions = new Pt3D[m_Mod[0]->getPartCount()];
+		assert(StoredPositions != NULL);
+		// copy the original positions of model 0 (store them)
+		int iPart; // a counter of Parts
+		for (iPart = 0; iPart < m_Mod[0]->getPartCount(); iPart++)
+		{
+			StoredPositions[iPart].x = m_aPositions[0][iPart].x;
+			StoredPositions[iPart].y = m_aPositions[0][iPart].y;
+			StoredPositions[iPart].z = m_aPositions[0][iPart].z;
+		}
+		// now the original positions of model 0 are stored
+
+
+		int iTransform; // a counter of geometric transformations
+		for (iTransform = 0; iTransform < NO_OF_TRANSFORM; iTransform++)
+		{
+			// for each geometric transformation to be done
+			// entry conditions:
+			// - models (m_Mod) exist and are available
+			// - matching (m_pMatching) exists and is empty
+			// - all properties are created and available (m_aDegrees and m_aPositions)
+
+			// recompute geometric properties according to the transformation iTransform
+			// but only for model 0
+			for (iPart = 0; iPart < m_Mod[0]->getPartCount(); iPart++)
+			{
+				// for each iPart, a part of the model iMod
+				m_aPositions[0][iPart].x *= dMulX[iTransform];
+				m_aPositions[0][iPart].y *= dMulY[iTransform];
+				m_aPositions[0][iPart].z *= dMulZ[iTransform];
+			}
+			// now the positions are recomputed
+			ComputeMatching();
+
+			// teraz m_pMatching istnieje i jest pełne
+			assert(m_pMatching != NULL);
+			assert(m_pMatching->IsFull() == true);
+
+			// wykorzystaj to dopasowanie i geometrię do obliczenia tymczasowej wartości miary
+			int iTempRes = CountPartsDistance();
+			// załóż sukces
+			assert(iTempRes == 1);
+			double dCurrentSim = m_adFactors[0] * double(m_iDV) +
+				m_adFactors[1] * double(m_iDD) +
+				m_adFactors[2] * double(m_iDN) +
+				m_adFactors[3] * double(m_dDG);
+			// załóż poprawną wartość podobieństwa
+			assert(dCurrentSim >= 0.0);
+
+			// porównaj wartość obliczoną z dotychczasowym minimum
+			if (dCurrentSim < dMinSimValue)
+			{
+				// jeśli uzyskano mniejszą wartość dopasowania, 
+				// to zapamiętaj to przekształcenie geometryczne i dopasowanie
+				dMinSimValue = dCurrentSim;
+				iMinSimTransform = iTransform;
+				SAFEDELETE(pMinSimMatching);
+				pMinSimMatching = new SimilMatching(*m_pMatching);
+				assert(pMinSimMatching != NULL);
+			}
+
+			// teraz już można usunąć stare dopasowanie (dla potrzeb następnego przebiegu pętli)
+			m_pMatching->Empty();
+		} // for ( iTransform )
+
+		// po pętli przywróć najlepsze dopasowanie
+		delete m_pMatching;
+		m_pMatching = pMinSimMatching;
+
+		DB(printf("Matching has been chosen!\n");)
+			// print the name of the chosen transformation:
+			// printf("Chosen transformation: %s\n", szTransformNames[ iMinSimTransform ] );
+
+			// i przywróć jednocześnie pozycje Parts modelu 0 dla tego dopasowania
+			// - najpierw przywroc Parts pozycje orginalne, po SVD
+			for (iPart = 0; iPart < m_Mod[0]->getPartCount(); iPart++)
+			{
+			m_aPositions[0][iPart].x = StoredPositions[iPart].x;
+			m_aPositions[0][iPart].y = StoredPositions[iPart].y;
+			m_aPositions[0][iPart].z = StoredPositions[iPart].z;
+			}
+		// - usun teraz zapamietane pozycje Parts
+		delete[] StoredPositions;
+		// - a teraz oblicz na nowo wspolrzedne wlasciwego przeksztalcenia dla model 0
+		for (iTransform = 0; iTransform <= iMinSimTransform; iTransform++)
+		{
+			// for each transformation before and INCLUDING iMinTransform
+			// do the transformation (only model 0)
+			for (iPart = 0; iPart < m_Mod[0]->getPartCount(); iPart++)
+			{
+				m_aPositions[0][iPart].x *= dMulX[iTransform];
+				m_aPositions[0][iPart].y *= dMulY[iTransform];
+				m_aPositions[0][iPart].z *= dMulZ[iTransform];
+			}
+		}
+
+		}
+		else
+		{
+			ComputeMatching();
+		}
+	// teraz dopasowanie musi byc pelne - co najmniej w jednym organizmie musza byc
+	// wszystkie elementy dopasowane
+	assert(m_pMatching->IsFull() == true);
+
+	//    _PrintDegrees(0);
+	//    _PrintDegrees(1);
+
+	DB(_PrintPartsMatching();)
+
+
+		return 1;
 }
 
 void ModelSimil::_PrintSeamnessTable(std::vector<int> *pTable, int iCount)
 {
-    int i;
-    printf("      ");
-    for (i = 0; i < iCount; i++)
-        printf("%3i ", i);
-    printf("\n      ");
-    for (i = 0; i < iCount; i++)
-    {
-
-        printf("%3i ", pTable->operator[](i));
-    }
-    printf("\n");
+	int i;
+	printf("      ");
+	for (i = 0; i < iCount; i++)
+		printf("%3i ", i);
+	printf("\n      ");
+	for (i = 0; i < iCount; i++)
+	{
+
+		printf("%3i ", pTable->operator[](i));
+	}
+	printf("\n");
 }
 
 /** Computes elements of similarity (m_iDD, m_iDN, m_dDG) based on underlying matching.
-    Assumptions:
-    - Matching (m_pMatching) exists and is full.
-        - Internal arrays m_aDegrees and m_aPositions exist and are properly filled in
-        Exit conditions:
-        - Elements of similarity are computed (m)iDD, m_iDN, m_dDG).
-        @return 1 if success, otherwise 0.
- */
+	Assumptions:
+	- Matching (m_pMatching) exists and is full.
+	- Internal arrays m_aDegrees and m_aPositions exist and are properly filled in
+	Exit conditions:
+	- Elements of similarity are computed (m)iDD, m_iDN, m_dDG).
+	@return 1 if success, otherwise 0.
+	*/
 int ModelSimil::CountPartsDistance()
 {
-    int i, temp;
-
-    // assume existence of m_pMatching
-    assert(m_pMatching != NULL);
-    // musi byc pelne!
-    assert(m_pMatching->IsFull() == true);
-
-    // roznica w stopniach
-    m_iDD = 0;
-    // roznica w liczbie neuronów
-    m_iDN = 0;
-    // roznica w odleglosci dopasowanych Parts
-    m_dDG = 0.0;
-
-    int iOrgPart, iOrgMatchedPart; // orginalny indeks Part i jego dopasowanego Part
-    int iMatchedPart; // indeks (wg sortowania) dopasowanego Part
-
-    // wykorzystanie dopasowania do zliczenia m_iDD - roznicy w stopniach
-    // i m_iDN - roznicy w liczbie neuronow
-    // petla w wiekszej tablicy
-    for (i = 0; i < m_aiPartCount[1 - m_iSmaller]; i++)
-    {
-        // dla kazdego elementu [i] z wiekszego organizmu
-        // pobierz jego orginalny indeks w organizmie z tablicy TDN
-        iOrgPart = m_aDegrees[ 1 - m_iSmaller ][ i ][ 0 ];
-        if (!(m_pMatching->IsMatched(1 - m_iSmaller, i)))
-        {
-            // gdy nie zostal dopasowany
-            // dodaj jego stopien do DD
-            m_iDD += m_aDegrees[1 - m_iSmaller][i][1];
-            // dodaj liczbe neuronow do DN
-            m_iDN += m_aDegrees[1 - m_iSmaller][i][3];
-            // i oblicz odleglosc tego Part od srodka organizmu (0,0,0)
-            // (uzyj orginalnego indeksu)
-            //no need to compute distane when m_dDG weight is 0
-            m_dDG += m_adFactors[3] == 0 ? 0 : m_aPositions[ 1 - m_iSmaller ][ iOrgPart ].length(); 
-        }
-        else
-        {
-            // gdy byl dopasowany
-            // pobierz indeks (po sortowaniu) tego dopasowanego Part
-            iMatchedPart = m_pMatching->GetMatchedIndex(1 - m_iSmaller, i);
-            // pobierz indeks orginalny tego dopasowanego Part
-            iOrgMatchedPart = m_aDegrees[ m_iSmaller ][ iMatchedPart ][0];
-            // dodaj ABS roznicy stopni do DD
-            temp = m_aDegrees[1 - m_iSmaller][i][1] -
-                    m_aDegrees[ m_iSmaller ][ iMatchedPart ][1];
-            m_iDD += abs(temp);
-            // dodaj ABS roznicy neuronow do DN
-            temp = m_aDegrees[1 - m_iSmaller][i][3] -
-                    m_aDegrees[ m_iSmaller ][ iMatchedPart ][3];
-            m_iDN += abs(temp);
-            // pobierz polozenie dopasowanego Part
-            Pt3D MatchedPartPos(m_aPositions[ m_iSmaller ][ iOrgMatchedPart ]);
-            // dodaj euklidesowa odleglosc Parts do sumy odleglosci
-            //no need to compute distane when m_dDG weight is 0
-            m_dDG +=m_adFactors[3] == 0 ? 0 :  m_aPositions[ 1 - m_iSmaller ][ iOrgPart ].distanceTo(MatchedPartPos);
-        }
-    }
-
-    // obliczenie i dodanie różnicy w liczbie neuronów OnJoint...
-    temp = m_aOnJoint[0][3] - m_aOnJoint[1][3];
-    m_iDN += abs(temp);
-    DB(printf("OnJoint DN: %i\n", abs(temp));)
-    // ... i Anywhere
-    temp = m_aAnywhere[0][3] - m_aAnywhere[1][3];
-    m_iDN += abs(temp);
-    DB(printf("Anywhere DN: %i\n", abs(temp));)
-
-    return 1;
+	int i, temp;
+
+	// assume existence of m_pMatching
+	assert(m_pMatching != NULL);
+	// musi byc pelne!
+	assert(m_pMatching->IsFull() == true);
+
+	// roznica w stopniach
+	m_iDD = 0;
+	// roznica w liczbie neuronów
+	m_iDN = 0;
+	// roznica w odleglosci dopasowanych Parts
+	m_dDG = 0.0;
+
+	int iOrgPart, iOrgMatchedPart; // orginalny indeks Part i jego dopasowanego Part
+	int iMatchedPart; // indeks (wg sortowania) dopasowanego Part
+
+	// wykorzystanie dopasowania do zliczenia m_iDD - roznicy w stopniach
+	// i m_iDN - roznicy w liczbie neuronow
+	// petla w wiekszej tablicy
+	for (i = 0; i < m_aiPartCount[1 - m_iSmaller]; i++)
+	{
+		// dla kazdego elementu [i] z wiekszego organizmu
+		// pobierz jego orginalny indeks w organizmie z tablicy TDN
+		iOrgPart = m_aDegrees[1 - m_iSmaller][i][0];
+		if (!(m_pMatching->IsMatched(1 - m_iSmaller, i)))
+		{
+			// gdy nie zostal dopasowany
+			// dodaj jego stopien do DD
+			m_iDD += m_aDegrees[1 - m_iSmaller][i][1];
+			// dodaj liczbe neuronow do DN
+			m_iDN += m_aDegrees[1 - m_iSmaller][i][3];
+			// i oblicz odleglosc tego Part od srodka organizmu (0,0,0)
+			// (uzyj orginalnego indeksu)
+			//no need to compute distane when m_dDG weight is 0
+			m_dDG += m_adFactors[3] == 0 ? 0 : m_aPositions[1 - m_iSmaller][iOrgPart].length();
+		}
+		else
+		{
+			// gdy byl dopasowany
+			// pobierz indeks (po sortowaniu) tego dopasowanego Part
+			iMatchedPart = m_pMatching->GetMatchedIndex(1 - m_iSmaller, i);
+			// pobierz indeks orginalny tego dopasowanego Part
+			iOrgMatchedPart = m_aDegrees[m_iSmaller][iMatchedPart][0];
+			// dodaj ABS roznicy stopni do DD
+			temp = m_aDegrees[1 - m_iSmaller][i][1] -
+				m_aDegrees[m_iSmaller][iMatchedPart][1];
+			m_iDD += abs(temp);
+			// dodaj ABS roznicy neuronow do DN
+			temp = m_aDegrees[1 - m_iSmaller][i][3] -
+				m_aDegrees[m_iSmaller][iMatchedPart][3];
+			m_iDN += abs(temp);
+			// pobierz polozenie dopasowanego Part
+			Pt3D MatchedPartPos(m_aPositions[m_iSmaller][iOrgMatchedPart]);
+			// dodaj euklidesowa odleglosc Parts do sumy odleglosci
+			//no need to compute distane when m_dDG weight is 0
+			m_dDG += m_adFactors[3] == 0 ? 0 : m_aPositions[1 - m_iSmaller][iOrgPart].distanceTo(MatchedPartPos);
+		}
+	}
+
+	// obliczenie i dodanie różnicy w liczbie neuronów OnJoint...
+	temp = m_aOnJoint[0][3] - m_aOnJoint[1][3];
+	m_iDN += abs(temp);
+	DB(printf("OnJoint DN: %i\n", abs(temp));)
+		// ... i Anywhere
+		temp = m_aAnywhere[0][3] - m_aAnywhere[1][3];
+	m_iDN += abs(temp);
+	DB(printf("Anywhere DN: %i\n", abs(temp));)
+
+		return 1;
 }
 
 /** Computes new positions of Parts of both of organisms stored in the object.
-        Assumptions:
-        - models (m_Mod) are created and valid
-        - positions (m_aPositions) are created and filled with original positions of Parts
-        - the sorting algorithm was not yet run on the array m_aDegrees
-        @return true if successful; false otherwise
- */
+		Assumptions:
+		- models (m_Mod) are created and valid
+		- positions (m_aPositions) are created and filled with original positions of Parts
+		- the sorting algorithm was not yet run on the array m_aDegrees
+		@return true if successful; false otherwise
+		*/
 bool ModelSimil::ComputePartsPositionsBySVD()
 {
-    bool bResult = true; // the result; assume a success
-
-    // check assumptions
-    // the models
-    assert(m_Mod[0] != NULL && m_Mod[0]->isValid());
-    assert(m_Mod[1] != NULL && m_Mod[1]->isValid());
-    // the position arrays
-    assert(m_aPositions[0] != NULL);
-    assert(m_aPositions[1] != NULL);
-
-    int iMod; // a counter of models
-    // use SVD to obtain different point of view on organisms
-    // and store the new positions (currently the original ones are still stored)
-    for (iMod = 0; iMod < 2; iMod++)
-    {
-        // prepare the vector of errors of approximation for the SVD
-        std::vector<double> vEigenvalues;
-        int nSize = m_Mod[ iMod ]->getPartCount();
-
-        double *pDistances = (double *) malloc(nSize * nSize * sizeof (double));
-
-        for (int i = 0; i < nSize; i++)
-        {
-            pDistances[i] = 0;
-        }
-
-        Model *pModel = m_Mod[ iMod ]; // use the model of the iMod (current) organism
-        int iP1, iP2; // indices of Parts in the model
-        Part *P1, *P2; // pointers to Parts
-        Pt3D P1Pos, P2Pos; // positions of parts 
-        double dDistance; // the distance between Parts
-        for (iP1 = 0; iP1 < pModel->getPartCount(); iP1++)
-        {
-            // for each iP1, a Part index in the model of organism iMod
-            P1 = pModel->getPart(iP1);
-            // get the position of the Part
-            P1Pos = P1->p;
+	bool bResult = true; // the result; assume a success
+
+	// check assumptions
+	// the models
+	assert(m_Mod[0] != NULL && m_Mod[0]->isValid());
+	assert(m_Mod[1] != NULL && m_Mod[1]->isValid());
+	// the position arrays
+	assert(m_aPositions[0] != NULL);
+	assert(m_aPositions[1] != NULL);
+
+	int iMod; // a counter of models
+	// use SVD to obtain different point of view on organisms
+	// and store the new positions (currently the original ones are still stored)
+	for (iMod = 0; iMod < 2; iMod++)
+	{
+		// prepare the vector of errors of approximation for the SVD
+		std::vector<double> vEigenvalues;
+		int nSize = m_Mod[iMod]->getPartCount();
+
+		double *pDistances = (double *)malloc(nSize * nSize * sizeof(double));
+
+		for (int i = 0; i < nSize; i++)
+		{
+			pDistances[i] = 0;
+		}
+
+		Model *pModel = m_Mod[iMod]; // use the model of the iMod (current) organism
+		int iP1, iP2; // indices of Parts in the model
+		Part *P1, *P2; // pointers to Parts
+		Pt3D P1Pos, P2Pos; // positions of parts 
+		double dDistance; // the distance between Parts
+		for (iP1 = 0; iP1 < pModel->getPartCount(); iP1++)
+		{
+			// for each iP1, a Part index in the model of organism iMod
+			P1 = pModel->getPart(iP1);
+			// get the position of the Part
+			P1Pos = P1->p;
 			if (fixedZaxis == 1)
-	    {
-		P1Pos.z = 0; //fixed vertical axis, so pretend all points are on the xy plane
-	    }
-            for (iP2 = 0; iP2 < pModel->getPartCount(); iP2++)
-            {
-                // for each (iP1, iP2), a pair of Parts index in the model
-                P2 = pModel->getPart(iP2);
-                // get the position of the Part
-                P2Pos = P2->p;
+			{
+				P1Pos.z = 0; //fixed vertical axis, so pretend all points are on the xy plane
+			}
+			for (iP2 = 0; iP2 < pModel->getPartCount(); iP2++)
+			{
+				// for each (iP1, iP2), a pair of Parts index in the model
+				P2 = pModel->getPart(iP2);
+				// get the position of the Part
+				P2Pos = P2->p;
 				if (fixedZaxis == 1)
-		{
-			P2Pos.z = 0; //fixed vertical axis, so pretend all points are on the xy plane
-		}
-                // compute the geometric (Euclidean) distance between the Parts
-                dDistance = P1Pos.distanceTo(P2Pos);
-                // store the distance
-                pDistances[iP1 * nSize + iP2] = dDistance;
-            } // for (iP2)
-        } // for (iP1)
-
-        MatrixTools::SVD(vEigenvalues, nSize, pDistances, m_aPositions[ iMod ]);
+				{
+					P2Pos.z = 0; //fixed vertical axis, so pretend all points are on the xy plane
+				}
+				// compute the geometric (Euclidean) distance between the Parts
+				dDistance = P1Pos.distanceTo(P2Pos);
+				// store the distance
+				pDistances[iP1 * nSize + iP2] = dDistance;
+			} // for (iP2)
+		} // for (iP1)
+
+		MatrixTools::SVD(vEigenvalues, nSize, pDistances, m_aPositions[iMod]);
 		if (fixedZaxis == 1) //restore the original vertical coordinate of each Part
-	{
-		for (int part = 0; part < pModel->getPartCount(); part++)
-		{
-			m_aPositions[iMod][part].z = pModel->getPart(part)->p.z;
-		}
-	}
-	
-        free(pDistances);
-    }
-
-    return bResult;
+		{
+			for (int part = 0; part < pModel->getPartCount(); part++)
+			{
+				m_aPositions[iMod][part].z = pModel->getPart(part)->p.z;
+			}
+		}
+
+		free(pDistances);
+	}
+
+	return bResult;
 }
 
 void ModelSimil::p_evaldistance(ExtValue *args, ExtValue *ret)
 {
-    Geno *g1 = GenoObj::fromObject(args[1]);
-    Geno *g2 = GenoObj::fromObject(args[0]);
-    if ((!g1) || (!g2))
-        ret->setEmpty();
-    else
-        ret->setDouble(EvaluateDistance(g1, g2));
-}
+	Geno *g1 = GenoObj::fromObject(args[1]);
+	Geno *g2 = GenoObj::fromObject(args[0]);
+	if ((!g1) || (!g2))
+		ret->setEmpty();
+	else
+		ret->setDouble(EvaluateDistance(g1, g2));
+}
